## dhcpcd 10.0.8

=== debian/changelog ===
dhcpcd (1:10.0.8-2) unstable; urgency=medium

  * [control]
    + Build-Depends: systemd-timesyncd [linux-any]
  * [rules]
    - Remove --with-hooks="ntp.conf timesyncd.conf" line.
    1) Debian ships systemd-timesync with Priority:standard on Linux.
    2) Upstream configure does not check for non-default configuration paths
       for Chrony or OpenNTPD, and it doesn't check for ntpsec at all.

 -- Martin-Éric Racine <martin-eric.racine@iki.fi>  Wed, 12 Jun 2024 19:54:51 +0300

dhcpcd (1:10.0.8-1) unstable; urgency=medium

  * New upstream version.
  * [patches]
    - Drop all patches. Merged upstream.
  * [control]
    = Cleanup by routine-update.

 -- Martin-Éric Racine <martin-eric.racine@iki.fi>  Fri, 24 May 2024 21:17:17 +0300

dhcpcd (1:10.0.6-5) unstable; urgency=medium

  * [control]
    = Bump Standards-Version to 4.7.0 (no change required).
  * [gbp.conf]
    + Set the Debian branch.

 -- Martin-Éric Racine <martin-eric.racine@iki.fi>  Mon, 13 May 2024 18:17:22 +0300

dhcpcd (1:10.0.6-4) unstable; urgency=medium

  [ Benjamin Drung ]
  * [patches]
    + hooks/30-hostname:
      Exit with 0 if setting hostname is not needed (LP: #2064926).

 -- Martin-Éric Racine <martin-eric.racine@iki.fi>  Tue, 07 May 2024 13:49:47 +0300

dhcpcd (1:10.0.6-3) unstable; urgency=medium

  * [control]
    = Migrate Build-Depends from pkg-config to pkgconf.
  * [autopkgtest]
    - Remove usrmerge tests since Bookworm and newer releases are merged.
    + Add Depends on systemd-timesyncd (Closes: #1069599).

 -- Martin-Éric Racine <martin-eric.racine@iki.fi>  Mon, 22 Apr 2024 07:32:46 +0300

dhcpcd (1:10.0.6-2) unstable; urgency=medium

  * [copyright]
    = Bump year for upstream and myself.
    = Migrate upstream URL to Github.
  * [control]
    Make our package bin-NMU friendly:
    + Make binary:all Depends on (>= ${source:Version}).
    = Move from ${binary:Version} to ${source:Version}.

 -- Martin-Éric Racine <martin-eric.racine@iki.fi>  Sun, 24 Mar 2024 09:59:07 +0200

=== debian/control ===
Source: dhcpcd
Maintainer: Martin-Éric Racine <martin-eric.racine@iki.fi>
Section: net
Priority: optional
Build-Depends: debhelper-compat (= 13),
               libssl-dev,
               libudev-dev [linux-any],
               pkgconf,
               systemd-timesyncd [linux-any]
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/debian/dhcpcd
Vcs-Git: https://salsa.debian.org/debian/dhcpcd.git
Homepage: https://roy.marples.name/projects/dhcpcd
Rules-Requires-Root: no

Package: dhcpcd-base
Architecture: any
Depends: adduser,
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: resolvconf | openresolv | systemd-resolved
Breaks: dhcpcd5 (<< ${source:Version}~)
Provides: dhcp-client
Replaces: dhcpcd5 (<< ${source:Version}~)
Description: DHCPv4 and DHCPv6 dual-stack client (binaries and exit hooks)
 dhcpcd provides seamless IPv4 and IPv6 auto-configuration:
  * DHCPv4 client
  * DHCPv6 client with Prefix Delegation (PD) support
  * IPv4 LL support (ZeroConf)
  * IPv6 SLAAC support
  * ARP address conflict resolution
  * ARP ping profiles
  * Wireless SSID profiles
 .
 This package provides the binaries, exit hooks and manual pages.
 .
 It offers a dual-stack substitute for ISC DHCP Client (dhclient) on systems
 where interfaces are configured by ifupdown via </etc/network/interfaces>
 using the DHCP method.
 .
 The init.d script and systemd service required for systems without ifupdown
 are packaged separately as dhcpcd.
 .
 Since Debian 12 (Bookworm), dhcpcd uses Predictable Network Interface Names
 on Linux ports. See NEWS.Debian for more details.

Package: dhcpcd
Architecture: all
Depends: dhcpcd-base (>= ${source:Version}~),
         sysvinit-utils (>= 3.05-4~) | lsb-base,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: wpasupplicant
Suggests: dhcpcd-gtk
Breaks: dhcpcd5 (<< ${source:Version}~)
Provides: dhcpcd
Replaces: dhcpcd5 (<< ${source:Version}~)
Description: DHCPv4 and DHCPv6 dual-stack client (init.d script & systemd unit)
 dhcpcd provides seamless IPv4 and IPv6 auto-configuration.
 .
 This package provides the optional init.d script and systemd service.
 .
 It should NOT be installed on systems where interfaces are configured
 by ifupdown via </etc/network/interfaces> using the DHCP method.

Package: dhcpcd5
Architecture: all
Section: oldlibs
Depends: dhcpcd (>= ${source:Version}~),
         ${misc:Depends},
         ${shlibs:Depends}
Description: DHCPv4 and DHCPv6 dual-stack client (dummy transitional package)
 This package depends on dhcpcd. It can safely be removed after upgrades.

=== debian/tests/control ===
Tests: timesyncd-ntp-servers-from-dhcp
Depends: dnsmasq,
         ethtool,
         iproute2,
         systemd-timesyncd,
         @
Restrictions: isolation-machine, needs-root, breaks-testbed
Architecture: linux-any

## dhcpcd 10.0.10

=== debian/changelog ===
dhcpcd (1:10.0.10-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Martin-Éric Racine <martin-eric.racine@iki.fi>  Mon, 09 Sep 2024 08:56:06 +0300

dhcpcd (1:10.0.10-1) unstable; urgency=medium

  * New upstream version.
  * [control]
    + dhcpcd-base: Provides: avahi-autoipd. Our IPV4LL fallback does the same.
  * [debian/][debian/tests]
    = Run 'shfmt -p' on all POSIX scripts.

 -- Martin-Éric Racine <martin-eric.racine@iki.fi>  Wed, 21 Aug 2024 18:20:25 +0300

dhcpcd (1:10.0.8-3) unstable; urgency=medium

  * [autopkgtest]
    = Merge common-ntp-servers-from-dhcp into timesyncd-ntp-servers-from-dhcp.
    + Implement basic autopkgtest using adequate.
  * [examples]
    = Rename and update DHCPv6-PD example configuration.

 -- Martin-Éric Racine <martin-eric.racine@iki.fi>  Thu, 08 Aug 2024 09:46:28 +0300

=== debian/control ===
--- 
+++ 
@@ -20,14 +20,15 @@
          ${shlibs:Depends}
 Suggests: resolvconf | openresolv | systemd-resolved
 Breaks: dhcpcd5 (<< ${source:Version}~)
-Provides: dhcp-client
+Provides: avahi-autoipd,
+          dhcp-client
 Replaces: dhcpcd5 (<< ${source:Version}~)
 Description: DHCPv4 and DHCPv6 dual-stack client (binaries and exit hooks)
  dhcpcd provides seamless IPv4 and IPv6 auto-configuration:
   * DHCPv4 client
   * DHCPv6 client with Prefix Delegation (PD) support
-  * IPv4 LL support (ZeroConf)
-  * IPv6 SLAAC support
+  * IPv4LL support (ZeroConf)
+  * IPv6RS support (SLAAC)
   * ARP address conflict resolution
   * ARP ping profiles
   * Wireless SSID profiles

## dhcpcd 10.1.0

=== src/Makefile ===
# dhcpcd Makefile

PROG=		dhcpcd
SRCS=		common.c control.c dhcpcd.c duid.c eloop.c logerr.c
SRCS+=		if.c if-options.c sa.c route.c
SRCS+=		dhcp-common.c script.c

CFLAGS?=	-O2
SUBDIRS+=	${MKDIRS}

TOP=		..
include		${TOP}/iconfig.mk

CSTD?=		c99
CFLAGS+=	-std=${CSTD}
CPPFLAGS+=	-I${TOP} -I${TOP}/src -I./crypt

SRCS+=		${DHCPCD_SRCS} ${PRIVSEP_SRCS}
DHCPCD_DEF?=	dhcpcd-definitions.conf
DHCPCD_DEFS=	dhcpcd-definitions.conf dhcpcd-definitions-small.conf

PCOMPAT_SRCS=	${COMPAT_SRCS:compat/%=${TOP}/compat/%}
PCRYPT_SRCS=	${CRYPT_SRCS:compat/%=${TOP}/compat/%}
OBJS+=		${SRCS:.c=.o} ${PCRYPT_SRCS:.c=.o} ${PCOMPAT_SRCS:.c=.o}

MAN5=		dhcpcd.conf.5
MAN8=		dhcpcd.8
CLEANFILES=	dhcpcd.conf.5 dhcpcd.8

FILES=		dhcpcd.conf
FILESDIR=	${SYSCONFDIR}

DEPEND!=	test -e .depend && echo ".depend" || echo ""

CLEANFILES+=	*.tar.xz

.PHONY:		import import-bsd dev test

.SUFFIXES:	.in

.in:
	${SED} ${SED_RUNDIR} ${SED_DBDIR} ${SED_LIBDIR} ${SED_HOOKDIR} \
		${SED_SYS} ${SED_SCRIPT} ${SED_DATADIR} \
		${SED_SERVICEEXISTS} ${SED_SERVICECMD} ${SED_SERVICESTATUS} \
		${SED_STATUSARG} \
		$< > $@

all: ${TOP}/config.h ${PROG} ${SCRIPTS} ${MAN5} ${MAN8}
	for x in ${SUBDIRS}; do cd $$x; ${MAKE} $@ || exit $$?; cd ..; done

dev:
	cd dev && ${MAKE}

.c.o:
	${CC} ${CFLAGS} ${CPPFLAGS} -c $< -o $@

CLEANFILES+=	dhcpcd-embedded.h dhcpcd-embedded.c

dhcpcd-embedded.h: genembedh ${DHCPCD_DEFS} dhcpcd-embedded.h.in
	${HOST_SH} ${.ALLSRC} $^ > $@

dhcpcd-embedded.c: genembedc ${DHCPCD_DEFS} dhcpcd-embedded.c.in
	${HOST_SH} ${.ALLSRC} $^ > $@

if-options.c: dhcpcd-embedded.h

.depend: ${SRCS} ${PCRYPT_SRCS} ${PCOMPAT_SRC}
	${CC} ${CPPFLAGS} -MM ${SRCS} ${PCRYPT_SRCS} ${PCOMPAT_SRCS} > .depend

depend: .depend

${PROG}: ${DEPEND} ${OBJS}
	${CC} ${LDFLAGS} -o $@ ${OBJS} ${LDADD}

lint:
	${LINT} -Suz ${CPPFLAGS} ${SRCS} ${PCRYPT_SRCS} ${PCOMPAT_SRCS}

_embeddedinstall: ${DHCPCD_DEF}
	${INSTALL} -d ${DESTDIR}${LIBEXECDIR}
	${INSTALL} -m ${CONFMODE} ${DHCPCD_DEF} ${DESTDIR}${LIBEXECDIR}

_proginstall: ${PROG}
	${INSTALL} -d ${DESTDIR}${SBINDIR}
	${INSTALL} -m ${BINMODE} ${PROG} ${DESTDIR}${SBINDIR}
	${INSTALL} -m ${DBMODE} -d ${DESTDIR}${DBDIR}

proginstall: _proginstall ${EMBEDDEDINSTALL}
	for x in ${SUBDIRS}; do cd $$x; ${MAKE} $@ || exit $$?; cd ..; done

_maninstall: ${MAN5} ${MAN8}
	${INSTALL} -d ${DESTDIR}${MANDIR}/man5
	${INSTALL} -m ${MANMODE} ${MAN5} ${DESTDIR}${MANDIR}/man5
	${INSTALL} -d ${DESTDIR}${MANDIR}/man8
	${INSTALL} -m ${MANMODE} ${MAN8} ${DESTDIR}${MANDIR}/man8

_confinstall:
	${INSTALL} -d ${DESTDIR}${SYSCONFDIR}
	# Install a new default config if not present
	if ! [ -e ${DESTDIR}${SYSCONFDIR}/dhcpcd.conf ]; then \
		${INSTALL} -m ${CONFMODE} dhcpcd.conf ${DESTDIR}${SYSCONFDIR}; \
		if [ "${UNCOMMENT_NTP}" = yes ]; then \
			${SED} -i \
			    -e 's/#option ntp_servers/option ntp_servers/' \
			    ${DESTDIR}/${SYSCONFDIR}/dhcpcd.conf; \
		fi; \
	fi
	
eginstall:

install: proginstall _maninstall _confinstall eginstall

clean:
	rm -f ${OBJS} ${PROG} ${PROG}.core ${CLEANFILES}
	for x in ${SUBDIRS}; do cd $$x; ${MAKE} $@ || exit $$?; cd ..; done

distclean: clean
	rm -f .depend
	rm -f *.diff *.patch *.orig *.rej

_import-src: ${SRCS} ${MAN5} ${MAN8}
	${INSTALL} -d ${DESTDIR}/src
	for x in defs.h ${SRCS} ${SRCS:.c=.h} dev.h ${MAN5} ${MAN8}; do \
		[ ! -e "$$x" ] || cp $$x ${DESTDIR}/src; \
	done
	cp dhcpcd.conf ${DESTDIR}/src
	if [ -n "${COMPAT_SRCS}" ]; then \
		${INSTALL} -d ${DESTDIR}/compat; \
		for x in ${COMPAT_SRCS} ${COMPAT_SRCS:.c=.h}; do \
			[ ! -e "../$$x" ] || cp "../$$x" ${DESTDIR}/compat; \
		done; \
	fi
	if ! grep HAVE_SYS_BITOPS_H ../config.h; then \
		cp ../compat/bitops.h ${DESTDIR}/compat; \
	fi
	if grep compat/consttime_memequal.h ../config.h; then \
		cp ../compat/consttime_memequal.h ${DESTDIR}/compat; \
	fi
	if [ -e ${DESTDIR}/compat/rb.c ]; then \
		cp ../compat/rbtree.h ${DESTDIR}/compat; \
	fi
	if [ -e ${DESTDIR}/compat/strtoi.c ]; then \
		cp ../compat/_strtoi.h ${DESTDIR}/compat; \
	fi
	if [ -n "${CRYPT_SRCS}" ]; then \
		${INSTALL} -d ${DESTDIR}/compat/crypt; \
		for x in ${CRYPT_SRCS} ${CRYPT_SRCS:.c=.h}; do \
			cp "../$$x" ${DESTDIR}/compat/crypt; \
		done; \
	fi
	# DragonFlyBSD builds base version with private crypto
	if [ `uname` = DragonFly ]; then rm ${DESTDIR}/compat/crypt/md5* ${DESTDIR}/compat/crypt/sha256*; fi

include ${TOP}/Makefile.inc

=== src/dev/Makefile ===
TOP=	../../
include ${TOP}/Makefile.inc
include ${TOP}/config.mk

CFLAGS?=	-O2
CSTD?=		c99
CFLAGS+=	-std=${CSTD}
CPPFLAGS+=	-I${TOP} -I${TOP}/src

DEVDIR=		${LIBDIR}/dhcpcd/dev
DSRC=		${DEV_PLUGINS:=.c}
DOBJ=		${DSRC:.c=.o}
DSOBJ=		${DOBJ:.o=.So}
DPLUGS=		${DEV_PLUGINS:=.so}

CLEANFILES+=	${DSOBJ} ${DPLUGS}

.SUFFIXES:	.So .so

.c.So:
	${CC} ${PICFLAG} -DPIC ${CPPFLAGS} ${CFLAGS} -c $< -o $@

.So.so:
	${CC} ${LDFLAGS} -shared -Wl,-x -o $@ -Wl,-soname,$@ \
	    $< ${LIBS}

all: ${DPLUGS}

udev.So:
CFLAGS+=	${LIBUDEV_CFLAGS}
CPPFLAGS+=	${LIBUDEV_CPPFLAGS}

udev.so:
LIBS+=		${LIBUDEV_LIBS}

proginstall: ${DPLUGS}
	${INSTALL} -d ${DESTDIR}${DEVDIR}
	${INSTALL} -m ${BINMODE} ${PROG} ${DPLUGS} ${DESTDIR}${DEVDIR}

eginstall:

install: proginstall

clean:
	rm -f ${CLEANFILES}

=== tests/crypt/Makefile ===
TOP=	../..
include ${TOP}/iconfig.mk

PROG=		run-test
SRCS=		run-test.c
SRCS+=		test_hmac_md5.c test_sha256.c

CFLAGS?=	-O2
CSTD?=		c99
CFLAGS+=	-std=${CSTD}

CPPFLAGS+=	-I${TOP} -I${TOP}/src

PCRYPT_SRCS=	${CRYPT_SRCS:compat/%=${TOP}/compat/%}
OBJS+=		${SRCS:.c=.o} ${PCRYPT_SRCS:.c=.o}

.c.o:
	${CC} ${CFLAGS} ${CPPFLAGS} -c $< -o $@

all: ${PROG}

clean:
	rm -f ${OBJS} ${PROG} ${PROG}.core ${CLEANFILES}

distclean: clean
	rm -f .depend
	rm -f *.diff *.patch *.orig *.rej

.depend: ${SRCS} ${PCRYPT_SRCS}
	${CC} ${CPPFLAGS} -MM ${SRCS} ${PCRYPT_SRCS}

${PROG}: ${DEPEND} ${OBJS}
	${CC} ${LDFLAGS} -o $@ ${OBJS} ${LDADD}

test: ${PROG}
	./${PROG}

=== debian/changelog ===
dhcpcd (1:10.1.0-8) unstable; urgency=medium

  * [debian/control]
    - dhcpcd-base: Drop the Provides avahi-autoipd (Closes: #1090742).
      1) Since Trixie, avahi-autoipd no longer Recommends isc-dhcp-client
         and ifupdown prioritizes dhcpcd in its search path.
      2) The only significant package that still Recommends avahi-autoipd
         is task-laptop, where it remains perfectly reasonable.

 -- Martin-Éric Racine <martin-eric.racine@iki.fi>  Tue, 11 Mar 2025 19:02:47 +0200

dhcpcd (1:10.1.0-7) unstable; urgency=medium

  * [debian/patches]
    + Add one cherry-pick from upstream Git for glibc6 2.41 (Closes: #1096157).

 -- Martin-Éric Racine <martin-eric.racine@iki.fi>  Mon, 17 Feb 2025 08:39:25 +0200

dhcpcd (1:10.1.0-6) unstable; urgency=medium

  * [autopkgtest]
    = Revert to previous veth recipe.

 -- Martin-Éric Racine <martin-eric.racine@iki.fi>  Fri, 07 Feb 2025 07:39:38 +0200

dhcpcd (1:10.1.0-5) unstable; urgency=medium

  * [autopkgtest]
    = Sanitize IPv6 commands in timesyncd-ntp-servers-from-dhcp.
  * [debian/patches]
    + Add two cherry-picks from upstream Git to fix IPv6.
    + Add "Forwarded: not-needed" to upstream Git cherry-picks.

 -- Martin-Éric Racine <martin-eric.racine@iki.fi>  Thu, 06 Feb 2025 10:01:15 +0200

dhcpcd (1:10.1.0-4) unstable; urgency=medium

  * [debian/patches]
    + Append the Applied-Upstream line to the Git cherry-pick from previous.
  * [debian/rules]
    + Explicitly configure --with-hooks="timesyncd.conf" to ensure it ships.

 -- Martin-Éric Racine <martin-eric.racine@iki.fi>  Sun, 02 Feb 2025 16:09:39 +0200

dhcpcd (1:10.1.0-3) unstable; urgency=medium

  * [copyright]
    = Bump my debian/* line to 2025.
  * [debian/NEWS]
    = Update the text to make differences with dhclient more obvious.
  * [debian/patches]
    + Git pick: exit 50-timesyncd if not found or disabled (Closes: #1086161).
    + Uncomment 'hostname' in dhcpcd.conf (Closes: #1089598).

 -- Martin-Éric Racine <martin-eric.racine@iki.fi>  Fri, 24 Jan 2025 21:33:57 +0200

dhcpcd (1:10.1.0-2) unstable; urgency=medium

  * [autopkgtest]
    + Restrictions: timesyncd-ntp-servers-from-dhcp flaky (Closes: #1087113).
      Thanks to Luca Boccassi for this kludge against 'dnsmasq' timeouts.
  * [copyright]
    = Update according to latest Lintian results (Closes: #1084139).
      Thanks to Phil Wyett for the extensive copyright review.

 -- Martin-Éric Racine <martin-eric.racine@iki.fi>  Sat, 09 Nov 2024 10:18:58 +0200

dhcpcd (1:10.1.0-1) unstable; urgency=medium

  * New upstream version.

 -- Martin-Éric Racine <martin-eric.racine@iki.fi>  Sat, 05 Oct 2024 08:24:12 +0300

dhcpcd (1:10.0.10-2) unstable; urgency=medium

  * [control]
    = Make dhcpcd-base Priority: important to match the override change.
      See #1038882.
  * [gbp.conf]
    + upstream-branch = upstream
  * [NEWS]
    + SLAAC uses privacy extensions as per upstream defaults.
    + No separate inet6 line is needed with dhcpcd.

 -- Martin-Éric Racine <martin-eric.racine@iki.fi>  Sun, 22 Sep 2024 08:56:39 +0300

=== debian/control ===
--- 
+++ 
@@ -15,13 +15,13 @@
 
 Package: dhcpcd-base
 Architecture: any
+Priority: important
 Depends: adduser,
          ${misc:Depends},
          ${shlibs:Depends}
 Suggests: resolvconf | openresolv | systemd-resolved
 Breaks: dhcpcd5 (<< ${source:Version}~)
-Provides: avahi-autoipd,
-          dhcp-client
+Provides: dhcp-client
 Replaces: dhcpcd5 (<< ${source:Version}~)
 Description: DHCPv4 and DHCPv6 dual-stack client (binaries and exit hooks)
  dhcpcd provides seamless IPv4 and IPv6 auto-configuration:

=== debian/tests/control ===
Tests: adequate
Depends: debhelper,
         adequate,
         @
Restrictions: superficial

Tests: timesyncd-ntp-servers-from-dhcp
Depends: dnsmasq,
         ethtool,
         iproute2,
         systemd-timesyncd,
         @
Restrictions: breaks-testbed,
              flaky,
              isolation-machine,
              needs-root
Architecture: linux-any

## dhcpcd 10.2.0

=== debian/changelog ===
dhcpcd (1:10.2.0-1) experimental; urgency=medium

  * New upstream version.
  * [debian/patches]
    - Delete all cherry-picks (merged upstream).

 -- Martin-Éric Racine <martin-eric.racine@iki.fi>  Mon, 17 Feb 2025 09:12:47 +0200

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
 Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/debian/dhcpcd
 Vcs-Git: https://salsa.debian.org/debian/dhcpcd.git
-Homepage: https://roy.marples.name/projects/dhcpcd
+Homepage: https://github.com/NetworkConfiguration/dhcpcd
 Rules-Requires-Root: no
 
 Package: dhcpcd-base
@@ -21,7 +21,8 @@
          ${shlibs:Depends}
 Suggests: resolvconf | openresolv | systemd-resolved
 Breaks: dhcpcd5 (<< ${source:Version}~)
-Provides: dhcp-client
+Provides: avahi-autoipd,
+          dhcp-client
 Replaces: dhcpcd5 (<< ${source:Version}~)
 Description: DHCPv4 and DHCPv6 dual-stack client (binaries and exit hooks)
  dhcpcd provides seamless IPv4 and IPv6 auto-configuration:

## dhcpcd 10.2.4

=== Makefile ===
SUBDIRS=	src hooks

PACKAGE=	dhcpcd
VERSION!=	sed -n 's/\#define VERSION[[:space:]]*"\(.*\)".*/\1/p' src/defs.h

DIST!=		if test -d .git; then echo "dist-git"; \
		else echo "dist-inst"; fi
FOSSILID?=	current
GITREF?=	HEAD

DISTSUFFIX=
DISTPREFIX?=	${PACKAGE}-${VERSION}${DISTSUFFIX}
DISTFILE?=	${DISTPREFIX}.tar.xz
DISTINFO=	${DISTFILE}.distinfo
DISTINFOMD=	${DISTINFO}.md
DISTSIGN=	${DISTFILE}.asc

CLEANFILES+=	*.tar.xz

.PHONY:		hooks import import-bsd tests

.SUFFIXES:	.in

all: config.h
	for x in ${SUBDIRS}; do cd $$x; ${MAKE} $@ || exit $$?; cd ..; done

depend: config.h
	for x in ${SUBDIRS}; do cd $$x; ${MAKE} $@ || exit $$?; cd ..; done

tests:
	cd $@; ${MAKE} $@

test: tests

hooks:
	cd $@; ${MAKE}

eginstall:
	for x in ${SUBDIRS}; do cd $$x; ${MAKE} $@ || exit $$?; cd ..; done

install:
	for x in ${SUBDIRS}; do cd $$x; ${MAKE} $@ || exit $$?; cd ..; done

proginstall:
	for x in ${SUBDIRS}; do cd $$x; ${MAKE} $@ || exit $$?; cd ..; done

clean:
	rm -rf cov-int dhcpcd.xz
	for x in ${SUBDIRS} tests; do cd $$x; ${MAKE} $@ || exit $$?; cd ..; done

distclean: clean
	rm -f config.h config.mk config.log \
		${DISTFILE} ${DISTINFO} ${DISTINFOMD} ${DISTSIGN}
	rm -f *.diff *.patch *.orig *.rej
	for x in ${SUBDIRS} tests; do cd $$x; ${MAKE} $@ || exit $$?; cd ..; done

dist-git:
	git archive --prefix=${DISTPREFIX}/ v${VERSION} | xz >${DISTFILE}

dist-inst:
	mkdir /tmp/${DISTPREFIX}
	cp -RPp * /tmp/${DISTPREFIX}
	(cd /tmp/${DISTPREFIX}; make clean)
	tar -cvJpf ${DISTFILE} -C /tmp ${DISTPREFIX}
	rm -rf /tmp/${DISTPREFIX}

dist: ${DIST}

distinfo: dist
	rm -f ${DISTINFO} ${DISTSIGN}
	${SHA256} ${DISTFILE} >${DISTINFO}
	wc -c <${DISTFILE} \
		| xargs printf 'Size   (${DISTFILE}) = %s\n' >>${DISTINFO}
	${PGP} --sign --armour --detach ${DISTFILE}
	chmod 644 ${DISTSIGN}
	ls -l ${DISTFILE} ${DISTINFO} ${DISTSIGN}

${DISTINFOMD}: ${DISTINFO}
	echo '```' >${DISTINFOMD}
	cat ${DISTINFO} >>${DISTINFOMD}
	echo '```' >>${DISTINFOMD}

release: distinfo ${DISTINFOMD}
	gh release create v${VERSION} \
		--title "${PACKAGE} ${VERSION}" --draft --generate-notes \
		--notes-file ${DISTINFOMD} \
		${DISTFILE} ${DISTSIGN}

snapshot:
	rm -rf /tmp/${DISTPREFIX}
	${INSTALL} -d /tmp/${DISTPREFIX}
	cp -RPp * /tmp/${DISTPREFIX}
	${MAKE} -C /tmp/${DISTPREFIX} distclean
	tar cf - -C /tmp ${DISTPREFIX} | xz >${DISTFILE}
	ls -l ${DISTFILE}

_import: dist
	rm -rf ${DESTDIR}/*
	${INSTALL} -d ${DESTDIR}
	tar xvpf ${DISTFILE} -C ${DESTDIR} --strip 1
	@${ECHO}
	@${ECHO} "============================================================="
	@${ECHO} "${PACKAGE}-${VERSION} imported to ${DESTDIR}"

import:
	${MAKE} _import DESTDIR=`if [ -n "${DESTDIR}" ]; then echo "${DESTDIR}"; else  echo /tmp/${DISTPREFIX}; fi`


_import-src: clean
	rm -rf ${DESTDIR}/*
	${INSTALL} -d ${DESTDIR}
	cp LICENSE README.md ${DESTDIR};
	for x in ${SUBDIRS}; do cd $$x; ${MAKE} DESTDIR=${DESTDIR} $@ || exit $$?; cd ..; done
	@${ECHO}
	@${ECHO} "============================================================="
	@${ECHO} "${PACKAGE}-${VERSION} imported to ${DESTDIR}"

import-src:
	${MAKE} _import-src DESTDIR=`if [ -n "${DESTDIR}" ]; then echo "${DESTDIR}"; else  echo /tmp/${DISTPREFIX}; fi`

include Makefile.inc

=== tests/eloop-bench/Makefile ===
TOP=	../..
include ${TOP}/iconfig.mk

PROG=		eloop-bench
SRCS=		eloop-bench.c
SRCS+=		${TOP}/src/eloop.c

CFLAGS?=	-O2
CSTD?=		c99
CFLAGS+=	-std=${CSTD}

#CPPFLAGS+=	-DNO_CONFIG_H
#CPPFLAGS+=	-DQUEUE_H=../compat/queue.h
CPPFLAGS+=	-I${TOP} -I${TOP}/src

# Default is to let eloop decide
#CPPFLAGS+=	-DHAVE_KQUEUE
#CPPFLAGS+=	-DHAVE_POLLTS
#CPPFLAGS+=	-DHAVE_PSELECT
#CPPFLAGS+=	-DHAVE_EPOLL
#CPPFLAGS+=	-DHAVE_PPOLL
CPPFLAGS+=	-DWARN_SELECT

PCOMPAT_SRCS=   ${COMPAT_SRCS:compat/%=${TOP}/compat/%}
OBJS+=          ${SRCS:.c=.o} ${PCOMPAT_SRCS:.c=.o}

.c.o: Makefile
	${CC} ${CFLAGS} ${CPPFLAGS} -c $< -o $@

all: ${PROG}

clean:
	rm -f ${OBJS} ${PROG} ${PROG}.core ${CLEANFILES}

distclean: clean
	rm -f .depend
	rm -f *.diff *.patch *.orig *.rej

depend:

${PROG}: ${DEPEND} ${OBJS}
	${CC} ${LDFLAGS} -o $@ ${OBJS} ${LDADD}

test: ${PROG}
	./${PROG}

=== debian/changelog ===
dhcpcd (1:10.2.4-4~bpo13+1) trixie-backports; urgency=medium

  * Rebuild for trixie-backports. No change required.

 -- Martin-Éric Racine <martin-eric.racine@iki.fi>  Tue, 23 Sep 2025 09:40:13 +0300

dhcpcd (1:10.2.4-4) unstable; urgency=medium

  * [dhcpcd.service]
    - Remove /etc/wpa_supplicant from ReadWritePaths (Closes: #1111467).

 -- Martin-Éric Racine <martin-eric.racine@iki.fi>  Fri, 29 Aug 2025 11:18:17 +0300

dhcpcd (1:10.2.4-3) unstable; urgency=medium

  * The "Welcome to Forky!" release. Uploading to unstable.

 -- Martin-Éric Racine <martin-eric.racine@iki.fi>  Sun, 10 Aug 2025 13:58:48 +0300

dhcpcd (1:10.2.4-2) experimental; urgency=medium

  * dhcpcd: Conflicts: network-manager (Closes: #1107683).
    This ensures that a daemonized dhcpcd and network-manager won't install on
    the same host. Meanwhile, dhcpcd-base itself does nothing without ifupdown
    or network-manager's dhcpcd backend.

 -- Martin-Éric Racine <martin-eric.racine@iki.fi>  Thu, 12 Jun 2025 11:03:25 +0300

dhcpcd (1:10.2.4-1) experimental; urgency=medium

  * New upstream version.

 -- Martin-Éric Racine <martin-eric.racine@iki.fi>  Fri, 06 Jun 2025 12:58:19 +0300

dhcpcd (1:10.2.3-1) experimental; urgency=medium

  * New upstream version:
    + Fix "SIGSYS with custom allocators" (Closes: #1101521).

 -- Martin-Éric Racine <martin-eric.racine@iki.fi>  Fri, 16 May 2025 17:52:16 +0300

dhcpcd (1:10.2.2-6) experimental; urgency=medium

  * [changelog]
    = Fix typo in previous ChangeLog entry.
  * [control]
    + dhcpcd: Recommends: | iwd | wireless-tools.
      dhcpcd uses netlink's NL80211_CMD_GET_SCAN to determine the SSID profile
      in /etc/dhcpcd.conf it should use. This remains agnostic to what tool is
      used to configure the radio and authenticate to the AccessPoint.
  * [Lintian]
    + Override: non-virtual-facility-in-initd-script:
      dhcpcd Should indeed start after "networking" if found.
  * dhcpcd:
    + init.d: Should-Start: networking (ifupdown), before dhcpcd, if found.
    + *.service: run After networking.service (ifupdown), if found.
    - Stop shipping an empty /etc/wpa_supplicant/ directory.

 -- Martin-Éric Racine <martin-eric.racine@iki.fi>  Sat, 10 May 2025 14:18:15 +0300

dhcpcd (1:10.2.2-5) experimental; urgency=medium

  * [gbp.conf]
    = Update Git repository layout to follow DEP-14.
      In addition to debian/latest, we have debian/bookworm and debian/trixie.

 -- Martin-Éric Racine <martin-eric.racine@iki.fi>  Tue, 08 Apr 2025 08:41:34 +0300

dhcpcd (1:10.2.2-4) experimental; urgency=medium

  * [control]
    = Shuffle the Suggests order to prioritize openresolv (Closes: #1102254).
  * [copyright]
    = Updated copyright info for debian/* files.

 -- Martin-Éric Racine <martin-eric.racine@iki.fi>  Mon, 07 Apr 2025 11:26:33 +0300

dhcpcd (1:10.2.2-3) experimental; urgency=medium

  * [salsa-ci.yml]
    + Implement basic CI support using the stock Debian pipeline include.

 -- Martin-Éric Racine <martin-eric.racine@iki.fi>  Wed, 26 Mar 2025 08:45:15 +0200

dhcpcd (1:10.2.2-2) experimental; urgency=medium

  * [debian/control]
    = Bumped Standards-Version to 4.7.2 (no change required).
    - dhcpcd-base: Drop the Provides avahi-autoipd (Closes: #1090742).
      1) Since Trixie, avahi-autoipd no longer Recommends isc-dhcp-client
         and ifupdown prioritizes dhcpcd in its search path.
      2) The only significant package that still Recommends avahi-autoipd
         is task-laptop, where it remains perfectly reasonable.

 -- Martin-Éric Racine <martin-eric.racine@iki.fi>  Tue, 11 Mar 2025 19:06:39 +0200

dhcpcd (1:10.2.2-1) experimental; urgency=medium

  * New upstream version.

 -- Martin-Éric Racine <martin-eric.racine@iki.fi>  Tue, 25 Feb 2025 15:47:12 +0200

dhcpcd (1:10.2.1-1) experimental; urgency=medium

  * New upstream version.
  * [autopkgtest]
    - Cautiously remove 'flaky' from timesyncd restrictions.
  * [debian/control]
    = Bumped Standards-Version to 4.7.1 (no change required).

 -- Martin-Éric Racine <martin-eric.racine@iki.fi>  Mon, 24 Feb 2025 07:02:56 +0200

dhcpcd (1:10.1.0-12) unstable; urgency=high

  * dhcpcd: Conflicts: network-manager (Closes: #1107683).
    This ensures that a daemonized dhcpcd and network-manager won't install on
    the same host and compete for control of the interfaces and resolver.
    Meanwhile, dhcpcd-base does nothing without ifupdown or network-manager's
    dhcpcd backend, so it remains harmless on a stock Trixie install.

 -- Martin-Éric Racine <martin-eric.racine@iki.fi>  Fri, 13 Jun 2025 14:09:46 +0300

dhcpcd (1:10.1.0-11) unstable; urgency=medium

  * [patches]
    + Upstream Git cherry-picks: prevent exit on timeout. We keep on trying to
      acquire an IP no matter what, switching to IPv4LL and back as needed.

 -- Martin-Éric Racine <martin-eric.racine@iki.fi>  Thu, 08 May 2025 21:47:28 +0300

dhcpcd (1:10.1.0-10) unstable; urgency=medium

  * [patches]
    + Upstream Git cherry-pick: Remove option rapid_commit from dhcpcd.conf

 -- Martin-Éric Racine <martin-eric.racine@iki.fi>  Sun, 20 Apr 2025 12:05:44 +0300

dhcpcd (1:10.1.0-9) unstable; urgency=medium

  * [autopkgtest]
    - Cautiously remove 'flaky' from timesyncd restrictions.
  * [control]
    = Bumped Standards-Version to 4.7.2 (no change required).
    = Migrate the Homepage field from Roy's website to Github.
    = Shuffle the Suggests order to prioritize openresolv (Closes: #1102254).
  * [copyright]
    = Update copyright info.
  * [gbp.conf]
    = Update Git repository layout to follow DEP-14.
      In addition to debian/latest, we have debian/bookworm and debian/trixie.
  * [salsa-ci.yml]
    + Implement basic CI support using the stock Debian pipeline include.

 -- Martin-Éric Racine <martin-eric.racine@iki.fi>  Thu, 10 Apr 2025 10:33:08 +0300

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
                libudev-dev [linux-any],
                pkgconf,
                systemd-timesyncd [linux-any]
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/debian/dhcpcd
 Vcs-Git: https://salsa.debian.org/debian/dhcpcd.git
 Homepage: https://github.com/NetworkConfiguration/dhcpcd
@@ -19,10 +19,9 @@
 Depends: adduser,
          ${misc:Depends},
          ${shlibs:Depends}
-Suggests: resolvconf | openresolv | systemd-resolved
+Suggests: openresolv | resolvconf | systemd-resolved
 Breaks: dhcpcd5 (<< ${source:Version}~)
-Provides: avahi-autoipd,
-          dhcp-client
+Provides: dhcp-client
 Replaces: dhcpcd5 (<< ${source:Version}~)
 Description: DHCPv4 and DHCPv6 dual-stack client (binaries and exit hooks)
  dhcpcd provides seamless IPv4 and IPv6 auto-configuration:
@@ -52,9 +51,10 @@
          sysvinit-utils (>= 3.05-4~) | lsb-base,
          ${misc:Depends},
          ${shlibs:Depends}
-Recommends: wpasupplicant
+Recommends: wpasupplicant | iwd | wireless-tools
 Suggests: dhcpcd-gtk
 Breaks: dhcpcd5 (<< ${source:Version}~)
+Conflicts: network-manager
 Provides: dhcpcd
 Replaces: dhcpcd5 (<< ${source:Version}~)
 Description: DHCPv4 and DHCPv6 dual-stack client (init.d script & systemd unit)

## dhcpcd 10.3.0

=== src/Makefile ===
--- 
+++ 
@@ -13,7 +13,7 @@
 
 CSTD?=		c99
 CFLAGS+=	-std=${CSTD}
-CPPFLAGS+=	-I${TOP} -I${TOP}/src -I./crypt
+CPPFLAGS+=	-I${TOP} -I${TOP}/src -I./crypt -I${TOP}/vendor
 
 SRCS+=		${DHCPCD_SRCS} ${PRIVSEP_SRCS}
 DHCPCD_DEF?=	dhcpcd-definitions.conf
@@ -21,7 +21,11 @@
 
 PCOMPAT_SRCS=	${COMPAT_SRCS:compat/%=${TOP}/compat/%}
 PCRYPT_SRCS=	${CRYPT_SRCS:compat/%=${TOP}/compat/%}
-OBJS+=		${SRCS:.c=.o} ${PCRYPT_SRCS:.c=.o} ${PCOMPAT_SRCS:.c=.o}
+PVENDOR_SRCS=	${VENDOR_SRCS:vendor/%=${TOP}/vendor/%}
+OBJS+=		${SRCS:.c=.o}
+OBJS+=		${PCRYPT_SRCS:.c=.o}
+OBJS+=		${PCOMPAT_SRCS:.c=.o}
+OBJS+=		${PVENDOR_SRCS:.c=.o}
 
 MAN5=		dhcpcd.conf.5
 MAN8=		dhcpcd.8
@@ -50,6 +54,9 @@
 
 dev:
 	cd dev && ${MAKE}
+
+../vendor/rbtree.o:
+	${CC} ${CFLAGS} ${CPPFLAGS} ${RBTREE_CFLAGS} ${RBTREE_CPPFLAGS} -c ../vendor/rbtree.c -o $@
 
 .c.o:
 	${CC} ${CFLAGS} ${CPPFLAGS} -c $< -o $@
@@ -118,8 +125,12 @@
 	rm -f *.diff *.patch *.orig *.rej
 
 _import-src: ${SRCS} ${MAN5} ${MAN8}
+	@if ! [ -e ../config.h ]; then \
+		echo "Cowardly refusing to import-src unless configured" >&2; \
+		exit 1; \
+	fi
 	${INSTALL} -d ${DESTDIR}/src
-	for x in defs.h ${SRCS} ${SRCS:.c=.h} dev.h ${MAN5} ${MAN8}; do \
+	for x in defs.h ${SRCS} ${SRCS:.c=.h} queue.h dev.h ${MAN5} ${MAN8}; do \
 		[ ! -e "$$x" ] || cp $$x ${DESTDIR}/src; \
 	done
 	cp dhcpcd.conf ${DESTDIR}/src
@@ -129,14 +140,21 @@
 			[ ! -e "../$$x" ] || cp "../$$x" ${DESTDIR}/compat; \
 		done; \
 	fi
+	if [ -n "${VENDOR_SRCS}" ]; then \
+		${INSTALL} -d ${DESTDIR}/vendor; \
+		cp ../vendor/queue.h ${DESTDIR}/vendor; \
+		for x in ${VENDOR_SRCS} ${VENDOR_SRCS:.c=.h}; do \
+			[ ! -e "../$$x" ] || cp "../$$x" ${DESTDIR}/compat; \
+		done; \
+	fi
 	if ! grep HAVE_SYS_BITOPS_H ../config.h; then \
 		cp ../compat/bitops.h ${DESTDIR}/compat; \
 	fi
 	if grep compat/consttime_memequal.h ../config.h; then \
 		cp ../compat/consttime_memequal.h ${DESTDIR}/compat; \
 	fi
-	if [ -e ${DESTDIR}/compat/rb.c ]; then \
-		cp ../compat/rbtree.h ${DESTDIR}/compat; \
+	if [ -e ${DESTDIR}/vendor/rbtree.c ]; then \
+		cp ../vendor/rbtree.h ${DESTDIR}/vendor; \
 	fi
 	if [ -e ${DESTDIR}/compat/strtoi.c ]; then \
 		cp ../compat/_strtoi.h ${DESTDIR}/compat; \

=== tests/Makefile ===
SUBDIRS=	crypt eloop-bench

all: 
	for x in ${SUBDIRS}; do cd $$x; ${MAKE} $@ || exit $$?; cd ..; done

install:

proginstall:

clean:
	for x in ${SUBDIRS}; do cd $$x; ${MAKE} $@ || exit $$?; cd ..; done

distclean: clean
	rm -f *.diff *.patch *.orig *.rej
	for x in ${SUBDIRS}; do cd $$x; ${MAKE} $@ || exit $$?; cd ..; done

test:
	for x in ${SUBDIRS}; do cd $$x; ${MAKE} $@ || exit $$?; cd ..; done

tests: test

=== debian/changelog ===
dhcpcd (1:10.3.0-7) unstable; urgency=medium

  * [dirs]
    + Add empty /usr/lib/dhcpcd to avoid breaking upgrades (Closes: #1124734).
  * [sysusers]
    = Revert to /usr/lib/dhcpcd as home directory. Our unpriviledged user can
      accommodate any path, apparently, so might as well keep the old one.

 -- Martin-Éric Racine <martin-eric.racine@iki.fi>  Tue, 06 Jan 2026 23:34:16 +0200

dhcpcd (1:10.3.0-6) unstable; urgency=medium

  * [preinst],[sysusers]
    + Migrate home from /usr/lib/dhcpcd to /usr/libexec if needed.
      Otherwise dhcpcd will complain that it cannot chroot to its exit hooks.

 -- Martin-Éric Racine <martin-eric.racine@iki.fi>  Sun, 04 Jan 2026 03:11:32 +0200

dhcpcd (1:10.3.0-5) unstable; urgency=medium

  * [lintian-overrides]
    + Add reference to #1124249 suggestion.
  * [sysusers]
    = Migrate home from /usr/lib/dhcpcd to /run/dhcpcd.

 -- Martin-Éric Racine <martin-eric.racine@iki.fi>  Sun, 04 Jan 2026 01:17:57 +0200

dhcpcd (1:10.3.0-4) unstable; urgency=medium

  * [rules]
    = Force delete EGHOOKS. We really don't want to ship them.
    = Move all other HOOKS to /usr/libexec (Closes: #1103429).
  * [lintian-overrides]
    + dhcpcd-base: executable-not-elf-or-script [usr/libexec/dhcpcd-hooks/*].
      As per #1124249 suggestion.
    - dhcpcd: non-virtual-facility-in-initd-script. Obsolete.
  * [examples]
    = Move 90-IPv6_debug into its own hooks subdirectory.
  * [copyright]
    = Update according to 'licensecheck' suggestions.
    = Bump my debian/* line to 2026.

 -- Martin-Éric Racine <martin-eric.racine@iki.fi>  Sat, 03 Jan 2026 18:33:05 +0200

dhcpcd (1:10.3.0-3) unstable; urgency=medium

  * [control]
    = Simplify bin:dhcpcd's long description (Closes: #1121452).
  * [patches]
    + Uncomment 'ntp_servers' in dhcpcd.conf (Closes: #1123962).

 -- Martin-Éric Racine <martin-eric.racine@iki.fi>  Thu, 25 Dec 2025 11:16:42 +0200

dhcpcd (1:10.3.0-2) unstable; urgency=low

  * [init.d],[systemd]
    = Run Before=networking.service for upcoming ifupdown (Closes: #1121016).
      Thanks Daniel Gröber.

 -- Martin-Éric Racine <martin-eric.racine@iki.fi>  Fri, 21 Nov 2025 11:09:54 +0200

dhcpcd (1:10.3.0-1) unstable; urgency=low

  * New upstream version.
  * Migrate user creation to sysusers.d declaration. Thanks Luca Boccassi.

 -- Martin-Éric Racine <martin-eric.racine@iki.fi>  Fri, 14 Nov 2025 21:14:38 +0200

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		--privsepuser=dhcpcd \
		--dbdir=/var/lib/dhcpcd \
		--rundir=/run/dhcpcd \
		--with-eghooks="" \
		--with-hooks="timesyncd.conf" \
		--with-openssl

override_dh_install:
	rm -fr debian/tmp/usr/share/dhcpcd
	dh_install

# Avoid starting the unconfigured service as it may break connectivity.
override_dh_installinit:
	dh_installinit --name=dhcpcd --no-start --no-stop-on-upgrade --no-restart-after-upgrade

override_dh_installsystemd:
	dh_installsystemd --name=dhcpcd --no-start --no-stop-on-upgrade --no-restart-after-upgrade
	dh_installsystemd --name=dhcpcd@ --no-start --no-stop-on-upgrade --no-restart-after-upgrade
